Index: main/trunk/greenstone3/web/sites/localsite/groupConfig.xml
===================================================================
--- main/trunk/greenstone3/web/sites/localsite/groupConfig.xml	(revision 32551)
+++ main/trunk/greenstone3/web/sites/localsite/groupConfig.xml	(revision 32552)
@@ -1,49 +1,79 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Collection groups configuration file
-     	Uncomment hierarchy and groupDescription elements to make collection groups work.
-	Describe your structure inside hiearchy tag as shown in example below.
-	Describe your groups in groupDescriptions element as shown below.
-	Without group tag with @name in groupDescriptions group will be invisible(but available).
-	If your collection not described in hierarchy element it will be visible after described
-	groups and collections at home page.
-		First level - home page
-			Second level - inside first group
-				Third level - inside second group
-					
-	-->
+
+A collection group is a set of collections that are presented under one
+icon/link on the home page. Clicking that link takes you to the group home page,
+which lists all the collections in that group.
+
+By default, there are no groups.
+
+Uncomment or add hierarchy and groupDescriptions elements to add groups to your library. 
+
+Describe your structure inside a hierarchy tag as shown in the examples below.
+
+Hierarchy can contain groups and/or collections. Groups can contain other groups and/or collections.
+The order they are listed is the order they will appear on the home page.
+
+Describe your groups in groupDescriptions element as shown in the example below.
+Without a matching group element in groupDescriptions, a group mentioned in the hierarchy 
+will be invisible (but available).
+
+If a collection is not mentioned in the hierarchy or as part of a group it will be listed on the main 
+home page after the specified groups and collections. 
+-->
+
+<!-- this example puts a few Greenstone demo collections into some groups. The home page 
+will display the demo group plus any unlisted collections. The demo group home page will display its two subgroups;
+their home pages will display their list of collections. -->
+
+<!--
 <groupConfig>
-	<!--
-	<hierarchy>
-		<group name="group2">
-			<collection name="solr-jdbm-demo" />
-		</group>
-		<group name="group1">
-			<group name="group3">
-				<collection name="solr-jdbm-demo" />
-				<group name="group1">
-					<collection name="solr-jdbm-demo" />
-					<group name="group1">
-					</group>
-				</group>
-			</group>
-		</group>
-		<collection name="lucene-jdbm-demo" />
-	</hierarchy>
-	<groupDescriptions>
-		<group name="group1">
-		</group>
-		<group name="group2">
-			<title>Group 2 title</title>
-			<description>Second group full description example</description>
-			<shortDescription>Second group short description example</shortDescription>
-			
-		</group>
-		<group name="group3">
-			<title>Group 3 title</title>
-			<description>Group 3 full description example </description>
-			<shortDescription>Group 3 short description example</shortDescription>
-			<backgroundImage>/images/Group3.jpg</backgroundImage>
-		</group>
-	</groupDescriptions>
-	-->
+  <hierarchy>
+    <group name="demo">
+      <group name="standard">
+	<collection name="solr-jdbm-demo" />
+	<collection name="lucene-jdbm-demo" />
+      </group>
+      <group name="dec">
+	<collection name="bibtex-e"/>
+	<collection name="dls-e"/>
+	<collection name="garish-e"/>
+	<collection name="isis-e"/>
+      </group>      
+    </group>
+  </hierarchy>
+  <groupDescriptions>
+    <group name="demo">
+      <title>Demo Collections</title>
+      <description>Collections for demonstration purposes, provided by the Greenstone project.</description>
+      <shortDescription>Greenstone demonstration collections</shortDescription>
+      <backgroundImage>/images/Group3.jpg</backgroundImage>
+    </group>
+    <group name="standard">
+      <title>Standard Demos</title>
+      <description>These collections are the standard demonstration collections that come with a Greenstone binary release.</description>
+      <shortDescription>Demonstration collections that come with the Greenstone binary.</shortDescription>
+    </group>
+    <group name="dec">
+      <title>Documented Example Collections</title>
+      <description>These documented example collections describe how they are constructed on their about page. Useful for learning about different Greenstone features.</description>
+      <shortDescription>Collections that describe how they were built.</shortDescription>
+    </group>
+  </groupDescriptions>
 </groupConfig>
+    -->
+
+<!-- If you want to put your collections into a specific order, you can list them in the hierarchy. Any unmentioned collections will be listed at the end. -->
+
+<!--
+<groupConfig>
+  <hierarchy>
+    <collection name="solr-jdbm-demo"/>
+    <collection name="lucene-jdbm-demo"/>
+    <collection name="paradise-gardens"/>
+  </hierarchy>
+</groupConfig>
+-->
+
+<groupConfig>
+</groupConfig>